﻿/**********************************************************

Make artboards from CSV file
Factory70 2012.02.21


1:A4アートボードをタイル状に8コ並べたものを、イラレで開いておきます。
2:左から [ アートボード名、横寸、縦寸 ] の順でリストを作って、CSVに保存しておきます。
3:あとは、ファイル→スクリプト でこのスクリプトを実行します。


*********************************************************/

try{
    if(app.documents.length > 0){
        
        //var docRef = app.activeDocument;
        var nowBoard = null;
        var ptX = 2.834645;//ポイントミリ換算用
        
        //開始の位置(ミリ)
        stX = 10;
        stY = -10;
        leftPlus = 0;//左に足すA4ボード数
        topPlus = 0;//上に足すA4ボード数
        
        var i = 0;
        var listFileName = File.openDialog ('サイズリストを指定してください');
        if(listFileName){
            fileObj = new File(listFileName);
            flag = fileObj.open("r");
            if(flag == true){
                while (! fileObj.eof ){
                   pointData = fileObj.readln();
                   pointData = pointData.replace (/\"/g, "");//データくくりの"を消す
                   data = pointData.split(/,|:/);
                   
                   //データを読み込み
                   var boardName = data[0];//ボード名=図版番号
                   var mWidth = parseFloat(data[1]);//幅(mm)
                   var mHeight = parseFloat(data[2]);//高さ(mm)
                   
                   
                   //ヘッダ行とばす
                   if( ! (boardName == "図版番号")){
                       
                       
                       //ポジションの計算
                       
                       //下端のY座標
                       var underY = stY - mHeight;
                       //右端のX座標
                       var rightX = stX + mWidth;
                       //上端のX座標→あとで。
                       
                       //underYが下端を超える場合は、A4シートを移動
                       if(leftPlus < 4){
                            underLimit = -284;
                        }else{
                            underLimit = -574;
                        }
                       if(underY < underLimit){
                           leftPlus ++;
                           if(leftPlus == 4){
                               topPlus ++;
                               stX = 10;
                               rightX = stX + mWidth;
                               stY = -304;
                               underY = stY - mHeight;
                            }else{
                           
                           stX = stX + 210;
                           if(leftPlus > 4){
                               stY = -304;
                           }else{
                               stY = -10;
                           }
                           underY = stY - mHeight;
                           rightX = rightX + 210;
                           }
                        }
                       
                       //alert (i + ":" + stX+','+ stY+','+ rightX+','+underY);//てす
                       
                       var docRef = app.activeDocument;
                       var numArtboardsBefore = docRef.artboards.length;
                       
                       //rect→(左端のX座標, 上端のY座標(下へ行くほど低い数字), 右端のX座標, 下端のY座標)
                       nowBoard = docRef.artboards.add ([stX * ptX, stY * ptX, rightX * ptX, underY * ptX]);
                       //単位はポイント。2.834645 points = 1 millimeter
                       
                       nowBoard.name = boardName;
                       nowBoard = null;
                       
                       //☆☆☆　アートボード名のテキストを入れる
                       var textPosLeft = stX * ptX;
                       var textPosTop = (stY * ptX) + 13;
                       //alert (i + ":" + textPosLeft+','+ textPosTop);//てす
                       var textRef = docRef.textFrames.add();//テキストオブジェクトをつくる
                       textRef.position = [textPosLeft, textPosTop];//位置をセット
                       textRef.contents = boardName;//テキストの内容をセット
                       textRef.textRange.size = 12;//テキストのサイズ(pt)
                       
                       
                       //次回の上端Y座標
                       stY = underY - 10;
                       i ++;
                   }
               
                }
            fileObj.close();
            }
        }else{
            throw('');
        }
    }else{
        throw new Error('ドキュメントが開かれていません。');
    }
}
catch(e) {
	alert( e.message, "スクリプト警告", true);
}



